# Android-Security-Roadmap

## Prerequisites

### Programing languages
- Java
- Kotlin
- XML
- C / C++
- Smali
- Assembly


### Networking
- OCI Model
- TCP / IP
- DNS
- HTTP
- SSL / TLS
- Proxy


### Cryptography
- Encryption
- Hashing
- MAC
- RSA 
- AES

## Android Design & Architecture
- Linux Kernel
- HAL
- Native Library
- Android Runtim
- Java API
- System App
- IPC
- binder
- Dalvik VM
- SandBoxing
- User & group 
- Filesystem / Partition
- File
- Database
- Sqlite
- Room
- Realm
- Sharedprefrence


## Permissions
- Aplication level
- protection levels
- Custom Permission


## Application Components
- Activity
- Service
- Broadcast Reciever
- Content Provider
- Manifest
- Intent
- Explicit
- Implicit
- Intent Filter
- Deep Link

## Core Api 
- Cryptography
- Navigation
- Interacting with Other Apps
- User Interface
- Images and graphics
- Audio & Video
- background processing
- App data and files
- Touch and input
- Sensors
- Connectivity


## Server Interaction
- Confidentiality & Authentication
- HTTP Library
- OkHttp
- Volley
- Retrofit
- Burp Suite
- SSL Pinning
- Certificate Validation
- Proxy & Sniffer for HTTP Traffic
- SSL / TLS Implementation


## Static Analysis
- APK Development Process
- APK Structure
- Decompiling
- JADX
- APKtool
- Code Patching
- Native Code
- Decompiling
- Disassembling
- Ghidra
- IDA


## Dynamic Analysis
- Stack trace
- Hooking
- Debuging
- ADB
- Emulator
- Genymotion
- AVD
- Bluestack
- Detection / Bypass
- Virtual-machine
- SSL-pin
- Rooting
- Tools
- Frida
- Drozer
- Objection
- Xposed 
- RMS
- MOBSF


## Common Attacks 
- Insecure Data Transmission
- Insecure IPC 
- Permission Issue
- Insecure Data Storage
- Webview Issue
- Insecure Logs
